#!/bin/bash
set -e
set -x

function spekk() {
ffmpeg -i "$@" /dev/shm/spectrogram.wav < /dev/null
sox /dev/shm/spectrogram.wav -c 1 -t sox - gain -n -B |
sox -V -t sox - -n spectrogram -x 1820 -y 1025
rm /dev/shm/spectrogram.wav
mv spectrogram.png "$@.png"
}

sox flip-flap-orig.flac flip-flap-24dB.flac vol -24dB
# audacity says 50+10.57 dB of white noise

ffmpeg -y -i flip-flap-orig.flac -map 0:a:0 -c:a libmp3lame -q:a 2 flip-flap-orig-loss.mp3
ffmpeg -y -i flip-flap-24dB.flac -map 0:a:0 -c:a libmp3lame -q:a 2 flip-flap-24dB-loss.mp3
ffmpeg -y -i flip-flap-orig-loss.mp3 flip-flap-orig-loss-mp3.flac
ffmpeg -y -i flip-flap-24dB-loss.mp3 flip-flap-24dB-loss-mp3.flac

ffmpeg -y -i flip-flap-orig.flac -map 0:a:0 -c:a libvorbis -q:a 5 flip-flap-orig-loss.ogg
ffmpeg -y -i flip-flap-24dB.flac -map 0:a:0 -c:a libvorbis -q:a 5 flip-flap-24dB-loss.ogg
ffmpeg -y -i flip-flap-orig-loss.ogg flip-flap-orig-loss-ogg.flac
ffmpeg -y -i flip-flap-24dB-loss.ogg flip-flap-24dB-loss-ogg.flac

ffmpeg -y -i flip-flap-orig.flac -map 0:a:0 -c:a aac -b:a 160k flip-flap-orig-loss.m4a
ffmpeg -y -i flip-flap-24dB.flac -map 0:a:0 -c:a aac -b:a 160k flip-flap-24dB-loss.m4a
ffmpeg -y -i flip-flap-orig-loss.m4a flip-flap-orig-loss-m4a.flac
ffmpeg -y -i flip-flap-24dB-loss.m4a flip-flap-24dB-loss-m4a.flac

sox -m -v 1 flip-flap-orig.flac -v -1 flip-flap-orig-loss-mp3.flac flip-flap-orig-diff-mp3.flac
sox -m -v 1 flip-flap-24dB.flac -v -1 flip-flap-24dB-loss-mp3.flac flip-flap-24dB-diff-mp3.flac vol 24dB
sox -m -v 1 flip-flap-orig.flac -v -1 flip-flap-orig-loss-ogg.flac flip-flap-orig-diff-ogg.flac
sox -m -v 1 flip-flap-24dB.flac -v -1 flip-flap-24dB-loss-ogg.flac flip-flap-24dB-diff-ogg.flac vol 24dB
sox -m -v 1 flip-flap-orig.flac -v -1 flip-flap-orig-loss-m4a.flac flip-flap-orig-diff-m4a.flac
sox -m -v 1 flip-flap-24dB.flac -v -1 flip-flap-24dB-loss-m4a.flac flip-flap-24dB-diff-m4a.flac vol 24dB

spekk flip-flap-orig-diff-mp3.flac
spekk flip-flap-24dB-diff-mp3.flac
spekk flip-flap-orig-diff-ogg.flac
spekk flip-flap-24dB-diff-ogg.flac
spekk flip-flap-orig-diff-m4a.flac
spekk flip-flap-24dB-diff-m4a.flac

# generate spectrogram for diff between orig.flac and orig.flac, should be pitch black
sox -m -v 1 flip-flap-orig.flac -v -1 flip-flap-orig.flac flip-flap-orig-diff-flac.flac
spekk flip-flap-orig-diff-flac.flac

# generate spectrogram for diff between orig.flac and 24db.flac, adding a blip at the end to prevent normalization
sox flip-flap-24dB.flac flip-flap-24dB-boosted.flac vol 24dB
sox -n -r 44100 blip.flac synth 1 sine 500 channels 2
sox -m -v 1 flip-flap-orig.flac -v -1 flip-flap-24dB-boosted.flac flip-flap-24dB-diff-flac.flac
sox blip.flac flip-flap-24dB-diff-flac.flac flip-flap-24dB-diff-flac2.flac
spekk flip-flap-24dB-diff-flac2.flac

# cleanup
true || {
rm flip-flap-24dB*.{flac,ogg,mp3,m4a}
rm flip-flap-orig*.{ogg,mp3,m4a}
rm flip-flap-orig-loss-*
rm flip-flap-*-diff-*.{flac,ogg,mp3,m4a}
rm blip.flac
}
